//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <map>
#include <algorithm>
#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

//  ,    
template <class K, class V>
class value_equals
{
  private:
    V value;
  public:
    //  ( ,   )
    value_equals (const V& v) : value(v) {}
    // 
    bool operator() (pair<const K, V> elem) { 
      return elem.second == value;
    }
};

int main(int argc, char* argv[])
{

  typedef map<float,float> FloatFloatMap;
  FloatFloatMap coll;
  FloatFloatMap::iterator pos;

  //  
  coll[1]=7; 
  coll[2]=4; 
  coll[3]=2; 
  coll[4]=3; 
  coll[5]=6; 
  coll[6]=1; 
  coll[7]=3;

  //     3.0
  cout << ToRus("    3.0\n");
  pos = coll.find(3.0); //  
  if (pos != coll.end()) {
    cout << pos->first << ": " 
         << pos->second << endl;
  }

  //     3.0
  cout << ToRus("    3.0\n");
  pos = find_if(coll.begin(),coll.end(), //  
                value_equals<float,float>(3.0)); 
  if (pos != coll.end()) {
    cout << pos->first << ": " 
         << pos->second << endl;
  }

  getch();
  return 0;
}

//---------------------------------------------------------------------------
